'------------------------------------------------------------------------
'
' Author      : Anas S.
' Date        : 20 Jan 2004
' Version     : 1.0
' Description : Uma aplicao simples para se conectar com 
'               um banco de dados Access que permite ao usurio
'               realizar as operaes bsicas: incluir, atualizar, 
'               excluir, filtrar e procurar dados.
'               O cdigo da rotina CreateControls foi criado por Radu G 
'               (em C# e convertido por Anas S. para VB.net) 
'
'------------------------------------------------------------------------

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports System.Data.OleDb

Namespace DataEasy
    '/ <summary>
    '/ Summary description for Form1.
    '/ </summary>
    Public Class MainFrm
        Inherits System.Windows.Forms.Form
#Region "Private Declarations"
        Private WithEvents btnNavPrev As System.Windows.Forms.Button
        Private WithEvents lblNavLocation As System.Windows.Forms.Label
        Private WithEvents btnNavNext As System.Windows.Forms.Button
        Private WithEvents btnAdd As System.Windows.Forms.Button
        Private WithEvents btnDelete As System.Windows.Forms.Button
        Private WithEvents btnCancel As System.Windows.Forms.Button
        Private WithEvents btnUpdate As System.Windows.Forms.Button
        Private WithEvents dGrid As System.Windows.Forms.DataGrid
        Private menuFile As System.Windows.Forms.MainMenu
        Private WithEvents menuF As System.Windows.Forms.MenuItem
        Private WithEvents menuF_open As System.Windows.Forms.MenuItem
        Private WithEvents menuItem4 As System.Windows.Forms.MenuItem
        Private WithEvents menuF_save As System.Windows.Forms.MenuItem
        Private WithEvents menuItem7 As System.Windows.Forms.MenuItem
        Private WithEvents menuF_exit As System.Windows.Forms.MenuItem
        Private WithEvents menuSearch As System.Windows.Forms.MenuItem
        Private components As System.ComponentModel.IContainer
        Private WithEvents comboTables As System.Windows.Forms.ComboBox

        Private colType() As String 'This array holds all the columnTypes;
        Private AutoMenu() As System.Windows.Forms.ContextMenu 'AutoDate or AutoNumber Options
        Private GPostion As Integer 'DataGrid's postion from Top
        Private DataLoaded As Boolean = False 'Check if the data is loaded into the system
        Private accessDataSet As DataSet 'the main DataSet
        Private ComboBoxText As String = "" 'the item selected in the ComboTables control
        Private dataSourceFile As String = "" 'source file of the .mdb file
        Private accessDataAdapter As OleDbDataAdapter 'the adapter to be used in conjunction with
        'the database file 
        Private mSearch As System.Windows.Forms.MenuItem
        Private accessConnection As New OleDbConnection()

#End Region
        Public Sub New()
            InitializeComponent()
        End Sub 'New
        'with icons using NiceMenu class

#Region "Windows Form Designer generated code"
        '/ <summary>
        '/ Clean up any resources being used.
        '/ </summary>
        Protected Overloads Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub 'Dispose


        '/ <summary>
        '/ Required method for Designer support - do not modify
        '/ the contents of this method with the code editor.
        '/ </summary>
        Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(MainFrm))
            Me.btnNavPrev = New System.Windows.Forms.Button
            Me.lblNavLocation = New System.Windows.Forms.Label
            Me.btnNavNext = New System.Windows.Forms.Button
            Me.btnAdd = New System.Windows.Forms.Button
            Me.btnDelete = New System.Windows.Forms.Button
            Me.btnCancel = New System.Windows.Forms.Button
            Me.btnUpdate = New System.Windows.Forms.Button
            Me.dGrid = New System.Windows.Forms.DataGrid
            Me.menuFile = New System.Windows.Forms.MainMenu(Me.components)
            Me.menuF = New System.Windows.Forms.MenuItem
            Me.menuF_open = New System.Windows.Forms.MenuItem
            Me.menuItem4 = New System.Windows.Forms.MenuItem
            Me.menuF_save = New System.Windows.Forms.MenuItem
            Me.menuItem7 = New System.Windows.Forms.MenuItem
            Me.menuF_exit = New System.Windows.Forms.MenuItem
            Me.mSearch = New System.Windows.Forms.MenuItem
            Me.menuSearch = New System.Windows.Forms.MenuItem
            Me.comboTables = New System.Windows.Forms.ComboBox
            CType(Me.dGrid, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.SuspendLayout()
            '
            'btnNavPrev
            '
            Me.btnNavPrev.Location = New System.Drawing.Point(288, 56)
            Me.btnNavPrev.Name = "btnNavPrev"
            Me.btnNavPrev.Size = New System.Drawing.Size(35, 23)
            Me.btnNavPrev.TabIndex = 50
            Me.btnNavPrev.Text = "<"
            Me.btnNavPrev.Visible = False
            '
            'lblNavLocation
            '
            Me.lblNavLocation.BackColor = System.Drawing.Color.White
            Me.lblNavLocation.Location = New System.Drawing.Point(320, 56)
            Me.lblNavLocation.Name = "lblNavLocation"
            Me.lblNavLocation.Size = New System.Drawing.Size(95, 23)
            Me.lblNavLocation.TabIndex = 51
            Me.lblNavLocation.Text = "Sem Registros"
            Me.lblNavLocation.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
            Me.lblNavLocation.Visible = False
            '
            'btnNavNext
            '
            Me.btnNavNext.Location = New System.Drawing.Point(416, 56)
            Me.btnNavNext.Name = "btnNavNext"
            Me.btnNavNext.Size = New System.Drawing.Size(35, 23)
            Me.btnNavNext.TabIndex = 52
            Me.btnNavNext.Text = ">"
            Me.btnNavNext.Visible = False
            '
            'btnAdd
            '
            Me.btnAdd.Location = New System.Drawing.Point(216, 88)
            Me.btnAdd.Name = "btnAdd"
            Me.btnAdd.Size = New System.Drawing.Size(75, 23)
            Me.btnAdd.TabIndex = 53
            Me.btnAdd.Text = "&Incluir"
            Me.btnAdd.Visible = False
            '
            'btnDelete
            '
            Me.btnDelete.Location = New System.Drawing.Point(296, 88)
            Me.btnDelete.Name = "btnDelete"
            Me.btnDelete.Size = New System.Drawing.Size(75, 23)
            Me.btnDelete.TabIndex = 54
            Me.btnDelete.Text = "&Deletar"
            Me.btnDelete.Visible = False
            '
            'btnCancel
            '
            Me.btnCancel.Location = New System.Drawing.Point(376, 88)
            Me.btnCancel.Name = "btnCancel"
            Me.btnCancel.Size = New System.Drawing.Size(75, 23)
            Me.btnCancel.TabIndex = 55
            Me.btnCancel.Text = "&Cancelar"
            Me.btnCancel.Visible = False
            '
            'btnUpdate
            '
            Me.btnUpdate.Location = New System.Drawing.Point(80, 88)
            Me.btnUpdate.Name = "btnUpdate"
            Me.btnUpdate.Size = New System.Drawing.Size(75, 23)
            Me.btnUpdate.TabIndex = 49
            Me.btnUpdate.Text = "&Atualizar"
            Me.btnUpdate.Visible = False
            '
            'dGrid
            '
            Me.dGrid.AllowSorting = False
            Me.dGrid.DataMember = ""
            Me.dGrid.Dock = System.Windows.Forms.DockStyle.Bottom
            Me.dGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText
            Me.dGrid.Location = New System.Drawing.Point(0, 303)
            Me.dGrid.Name = "dGrid"
            Me.dGrid.Size = New System.Drawing.Size(576, 144)
            Me.dGrid.TabIndex = 47
            '
            'menuFile
            '
            Me.menuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuF, Me.mSearch})
            '
            'menuF
            '
            Me.menuF.Index = 0
            Me.menuF.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuF_open, Me.menuItem4, Me.menuF_save, Me.menuItem7, Me.menuF_exit})
            Me.menuF.Shortcut = System.Windows.Forms.Shortcut.CtrlS
            Me.menuF.Text = "&Arquivo"
            '
            'menuF_open
            '
            Me.menuF_open.Index = 0
            Me.menuF_open.Text = "&Abrir"
            '
            'menuItem4
            '
            Me.menuItem4.Index = 1
            Me.menuItem4.Text = "-"
            '
            'menuF_save
            '
            Me.menuF_save.Enabled = False
            Me.menuF_save.Index = 2
            Me.menuF_save.Shortcut = System.Windows.Forms.Shortcut.CtrlS
            Me.menuF_save.Text = "&Salvar"
            '
            'menuItem7
            '
            Me.menuItem7.Index = 3
            Me.menuItem7.Text = "-"
            '
            'menuF_exit
            '
            Me.menuF_exit.Index = 4
            Me.menuF_exit.Text = "Sa&ir"
            '
            'mSearch
            '
            Me.mSearch.Index = 1
            Me.mSearch.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuSearch})
            Me.mSearch.Text = "&Procurar"
            '
            'menuSearch
            '
            Me.menuSearch.Enabled = False
            Me.menuSearch.Index = 0
            Me.menuSearch.Shortcut = System.Windows.Forms.Shortcut.F12
            Me.menuSearch.Text = "&Dados"
            '
            'comboTables
            '
            Me.comboTables.Location = New System.Drawing.Point(160, 56)
            Me.comboTables.Name = "comboTables"
            Me.comboTables.Size = New System.Drawing.Size(121, 21)
            Me.comboTables.TabIndex = 56
            Me.comboTables.Text = "Tabelas"
            Me.comboTables.Visible = False
            '
            'MainFrm
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(576, 447)
            Me.Controls.Add(Me.dGrid)
            Me.Controls.Add(Me.comboTables)
            Me.Controls.Add(Me.btnNavPrev)
            Me.Controls.Add(Me.lblNavLocation)
            Me.Controls.Add(Me.btnNavNext)
            Me.Controls.Add(Me.btnAdd)
            Me.Controls.Add(Me.btnDelete)
            Me.Controls.Add(Me.btnCancel)
            Me.Controls.Add(Me.btnUpdate)
            Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
            Me.Menu = Me.menuFile
            Me.MinimumSize = New System.Drawing.Size(460, 200)
            Me.Name = "MainFrm"
            Me.Text = "AcessoFcil"
            CType(Me.dGrid, System.ComponentModel.ISupportInitialize).EndInit()
            Me.ResumeLayout(False)

        End Sub 'InitializeComponent

#End Region

#Region "Menu Click Events"
        ' Evento disparado quando alguem clica em um item do menu
        Private Sub menuF_open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuF_open.Click
            'verifica se houve alteraes nos dados
            If Check_If_Data_Changed() = True Then
                'Avia o usurio que os dados no esto salvos
                Dim r As DialogResult = MessageBox.Show("O Banco de dados foi modificado, tem certeza que deseja abarir o arquivo sem salvar as alteraes?", "Abrir arquivo sem salvar", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation)
                If r = DialogResult.No Then Exit Sub
            End If
            menuOpenClick()
        End Sub

        Private Sub menuF_save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuF_save.Click
            'Salva as mudanas para o banco de dados
            btnUpdate.Focus()
            Dim R As DialogResult = MessageBox.Show("Tem certeza de que deseja salvar as alteraes ?", "Salvar", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation)
            If R = DialogResult.Yes Then Save_File()
        End Sub

        Private Sub menuF_exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuF_exit.Click
            'Sai da aplicao
            'Verifica e avisa o usurio se os dados no foram salvos
            If Check_If_Data_Changed() = True Then
                Dim r As DialogResult = MessageBox.Show("O banco de dados foi alterado, deseja sair sem salvar?", "Sair sem salvar", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation)
                If r = DialogResult.Yes Then
                    Application.Exit()
                End If
            Else
                Application.Exit()
            End If
        End Sub
        Private Sub menuSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuSearch.Click
            'Procura  os dados usando tcnicas de busca ou usando filtros a fim de exibir os dados 
            If DataLoaded = False Then Exit Sub

            menuSearchClick()

        End Sub

#End Region

#Region "Save"
        'Trata o salvamento dos dados para o arquivo principal
        Private Sub Save_File()
            ' Cria um novo dataset para tratar as alteraes que foram feitas
            Dim objDataSetChanges As New DataSet()
            ' Para qualquer edio atual
            Me.BindingContext(accessDataSet, comboTables.Text).EndCurrentEdit()
            ' Obtem as alteraes que foram feitas no dataset
            objDataSetChanges = CType(accessDataSet.GetChanges(), DataSet)
            ' verifica se houve qualquer alterao 
            If Not (objDataSetChanges Is Nothing) Then
                ' Atualiza a fonte de dados chamando o mtodo update  e passando o dataset e os parametros
                UpdateDataSource(objDataSetChanges)
                'Verifica se  a conexo esta fechada
                If Me.accessConnection.State.ToString() <> "Closed" Then
                    Me.accessConnection.Close()
                End If
            End If
        End Sub 'Save_File
#End Region

#Region "Menu Open"
        ' Menu Abrir
        Public Sub menuOpenClick()
            Dim openFile As New OpenFileDialog()
            openFile.FileName = ""
            'Filtrar para exibir somente arquivos *.mdb 
            openFile.Filter = "Microsoft Access Application (*.mdb)|*.mdb"

            Dim res As System.Windows.Forms.DialogResult = openFile.ShowDialog()
            If res = System.Windows.Forms.DialogResult.Cancel Then
                Return
            End If
            'Muda o icone do mouse e titulo do formulario
            Me.Cursor = Cursors.WaitCursor
            Me.Text = "FacilAcesso : Carregando Dados, aguarde..."

            'Os parametros da conexo
            accessConnection.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source= " + openFile.FileName '

            Dim stDataSource As String = openFile.FileName
            dataSourceFile = openFile.FileName
            'remover controles criados dinamicamente no formulario
            removeMadeControls()

            Try
                ' Tenta preencher o dataset temporario
                ' Desabilita a verificao de restries para o dataset
                ' Isto permite que o adater preencha o dataset sem considerar
                ' dependencias entre as tabelas
                accessDataSet = New DataSet()
                accessDataSet.EnforceConstraints = False

                CType(Me.accessDataSet, System.ComponentModel.ISupportInitialize).BeginInit()

                Try
                    ' Abra a conexao
                    accessConnection.Open()

                    'Obtem o numero de tabelas que o dataset contem
                    Dim schemaTable As DataTable = accessConnection.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, New Object() {Nothing, Nothing, Nothing, "TABLE"})

                    'Atualiza a combobox com o numero de tabelas do dataset
                    'E exibe o nome da primeira tabela no combobox
                    comboTables.Items.Clear()

                    Dim i As Integer = 0

                    Dim r As DataRow
                    For Each r In schemaTable.Rows
                        If i = 0 Then
                            comboTables.Text = r("TABLE_NAME").ToString()
                            comboTables.Items.Add(r("TABLE_NAME").ToString())
                        Else
                            comboTables.Items.Add(r("TABLE_NAME").ToString())
                        End If
                        i += 1
                    Next r

                    'carrega dados
                    ComboBoxText = comboTables.Text
                    If menuSearch.Enabled = True Then
                        removeMadeControls()
                    End If
                    'chama a rotina LoadData
                    LoadData(("Select * From [" + comboTables.Text + "]"))
                Catch fillException As System.Data.OleDb.OleDbException
                    'Se houver erros na carga dos dados informa o erro
                    MessageBox.Show(fillException.Message)
                Finally
                    ' Habilita a verificao de restries
                    accessDataSet.EnforceConstraints = True
                    ' fecha a conexo 
                    accessConnection.Close()
                End Try
            Catch eFillDataSet As System.Data.OleDb.OleDbException
                Throw eFillDataSet
            End Try
            'Retorna o cursor do mouse e o titulo do formulario
            Me.Cursor = Cursors.Arrow
            Me.Text = "FacilAcesso"
        End Sub 'menuOpenClick

#End Region

#Region "Menu Search Click"
        'Search Menu is clicked
        Private Sub menuSearchClick()

            'Create a new instance of the search form
            'Specifying the datasource and table to view
            Dim sfrm = New searchfrm(Me, dataSourceFile, "[" + comboTables.Text + "]", "Select * From [" + comboTables.Text + " ]")
            ' Create a new dataset to hold the changes that have been made to the main dataset.
            Dim objDataSetChanges As New DataSet()
            ' Stop any current edits.
            Me.BindingContext(accessDataSet, comboTables.Text).EndCurrentEdit()
            ' Get the changes that have been made to the main dataset.
            objDataSetChanges = CType(accessDataSet.GetChanges(), DataSet)
            ' Check to see if any changes have been made.
            If Not (objDataSetChanges Is Nothing) Then
                'alert the user that in order to view the same data
                'in the search he/she has to save the file
                Dim r As DialogResult = MessageBox.Show("The database file changed, in oder to see your changes in the search form you have to save, continue any way?", "Change In Data File Detected", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation)
                If r = DialogResult.No Then
                    Return
                End If
            End If
            Form.ActiveForm.Enabled = False
            sfrm.Show()
        End Sub 'menuSearchClick

#End Region

#Region "LoadData"
        'Os dados so lidos do banco de dados
        'e todos os parametros sao definidos para construir
        'A string Select para montar o instruo SQL para exibir os dados
        Public Sub LoadData(ByVal SelectString As String)
            Me.Cursor = Cursors.WaitCursor
            Me.Text = "AcessoFacil: Carregando Dados , aguarde..."
            Try
                accessDataSet = New DataSet()

                Dim accessDataTable As DataTable
                'cria uma nova instanca para os comandos selecionar, incluir e atualizar e
                'deletar a ser usada com o adapter
                Dim accessSelectCommand As New OleDbCommand()
                Dim accessInsertCommand As New OleDbCommand()
                Dim accessUpdateCommand As New OleDbCommand()
                Dim accessDeleteCommand As New OleDbCommand()

                accessDataAdapter = Nothing
                accessDataAdapter = New OleDbDataAdapter()

                accessSelectCommand.CommandText = SelectString
                accessSelectCommand.Connection = accessConnection
                accessDataAdapter.SelectCommand = accessSelectCommand

                ' Tenta preencher o dataset atravves de accessDataAdapter
                accessDataAdapter.TableMappings.AddRange(New System.Data.Common.DataTableMapping() {New System.Data.Common.DataTableMapping("Table", comboTables.Text)})
                'preenche o DataSet com as restries da fonte de dados
                accessDataAdapter.FillSchema(accessDataSet, SchemaType.Source, comboTables.Text)

                ' preenche o dataset
                accessDataAdapter.Fill(accessDataSet)

                'cria uma instancia para o datatable
                accessDataTable = accessDataSet.Tables(comboTables.Text)

                ' Cria comandos para incluir e parametros
                accessInsertCommand.Connection = accessConnection
                make_Insert_Command(accessDataTable, accessInsertCommand)
                accessDataAdapter.InsertCommand = accessInsertCommand

                ' Os comandos dinamicos para atualizar e parametros
                accessUpdateCommand.Connection = accessConnection
                make_Update_Command(accessDataTable, accessUpdateCommand)
                accessDataAdapter.UpdateCommand = accessUpdateCommand

                ' Os comandos dinamicos para deletar e parametros
                accessDeleteCommand.Connection = accessConnection
                make_Delete_Command(accessDataTable, accessDeleteCommand)
                accessDataAdapter.DeleteCommand = accessDeleteCommand

                ' posicao dos controles dinamicos
                Dim controlTop As Integer = 10
                Dim controlLeft As Integer = 10

                'Obtem todos os System.DataTypes das coluna na tabela e atribui
                'ao array colType
                colType = New String(accessDataTable.Columns.Count) {}

                'O AutoMenu  criado o qual permitira que o usurio
                'incluir automaticamente o incremento de numeros (+1 na ltima celula)
                'ou incluir a data de hoje para a coluna com tipo de dados datetime
                AutoMenu = New ContextMenu(accessDataTable.Columns.Count) {}

                'Cria de forma dinamica todos os textboxes e Labels
                'o quel sero tratados com a informao vinculada ao banco de dados
                'tornando mais simples a incluso de dados
                Dim i As Integer
                For i = 0 To accessDataTable.Columns.Count - 1
                    colType(i) = accessDataTable.Columns(i).DataType.ToString()

                    'Cria o controle (Label)
                    Dim LabelControl As Label = CType(CreateControls.MakeControl("Label", 30, 100, controlLeft, controlTop + 3, accessDataTable.Columns(i).Caption + " :", "cLabel" + i.ToString()), Label)

                    'Cria o controle (TextBox)
                    Dim TextControl As TextBox = CType(CreateControls.MakeControl("TextBox", 30, 100, controlLeft + 100, controlTop, accessDataTable.Columns(i).Caption, "cText" + i.ToString()), TextBox)

                    'Atribui o TabIndex sequenciamente para o textbox criado
                    TextControl.TabIndex = i

                    'vincula o controle textbox control a coluna da tabela do banco de dados 
                    TextControl.DataBindings.Add(New System.Windows.Forms.Binding("Text", Me.accessDataSet, comboTables.Text + "." + accessDataSet.Tables(comboTables.Text).Columns(i).ToString()))

                    'Inclui os controles no formulario
                    Me.Controls.Add(TextControl)
                    Me.Controls.Add(LabelControl)

                    'Arruma os controles no formulario
                    If i = accessDataTable.Columns.Count - 1 Then
                        Exit For
                    End If
                    If controlLeft = 10 Then
                        controlLeft = 220
                    Else
                        If controlLeft = 220 And accessDataTable.Columns.Count > 6 Then
                            controlLeft = 430
                            Me.Width = 680
                        Else
                            controlTop += LabelControl.Height + 10
                            controlLeft = 10
                        End If
                    End If
                Next i
                arrange_Controls(controlTop, accessDataTable.Columns.Count)

                'Liga o controle datagrid control a tabela do banco de dados
                dGrid.SetDataBinding(accessDataSet, comboTables.Text)


                'Cria AutoInsertion da Data para as colunas do tipo  'DateTime' 

                For i = 0 To accessDataTable.Columns.Count - 1
                    If colType(i) = "System.Int32" Then
                        Dim Item1 As New MenuItem("Autonumeracao")
                        AddHandler Item1.Click, AddressOf Me.cMenuClick
                        AutoMenu(i) = New ContextMenu(New MenuItem() {Item1})
                    Else
                        If colType(i) = "System.DateTime" Then
                            Dim Item1 As New MenuItem("Insero automatica da data atual")
                            AddHandler Item1.Click, AddressOf Me.cMenuClick
                            AutoMenu(i) = New ContextMenu(New MenuItem() {Item1})
                        End If
                    End If
                Next i
                'refresca a visao do banco de dados no grid
                DataSet_PositionChanged()
                ' captura qualquer erro e exibe
            Catch e As System.Data.OleDb.OleDbException
                MessageBox.Show(e.Message)
            End Try
            Me.Cursor = Cursors.Arrow
            Me.Text = "AcessoFacil"
        End Sub 'LoadData

#End Region

#Region "make_Insert_Command"
        'A string de comando e os parametros so atribuiros de forma dinamica para o comando de incluso
        Private Sub make_Insert_Command(ByVal datatable As DataTable, ByVal insertcommand As OleDbCommand)
            Dim insertString1 As String = "INSERT INTO [" + comboTables.Text + "] ("
            Dim insertString2 As String = ""

            Dim i As Integer
            For i = 0 To datatable.Columns.Count - 1
                insertString1 += "[" + datatable.Columns(i).Caption + "]"
                insertString2 += "?"

                If i <> datatable.Columns.Count - 1 Then
                    insertString1 += ","
                    insertString2 += ","
                Else
                    insertString1 += ") VALUES (" + insertString2 + ")"
                End If
                insertcommand.Parameters.Add(New System.Data.OleDb.OleDbParameter(datatable.Columns(i).Caption, System.Data.OleDb.OleDbType.Variant, 16, datatable.Columns(i).Caption))
            Next i
            insertcommand.CommandText = insertString1
        End Sub 'make_Insert_Command

#End Region

#Region "make_Update_Command"
        'O comando atualzar e atribuido com a string de comando e os parametros
        Private Sub make_Update_Command(ByVal datatable As DataTable, ByVal updatecommand As OleDbCommand)
            Dim updateString1 As String = "UPDATE [" + comboTables.Text + "] SET "
            Dim updateString2 As String = ""

            Dim i As Integer
            For i = 0 To datatable.Columns.Count - 1
                If datatable.Columns(i).AutoIncrement <> True Then
                    updateString1 += "[" + datatable.Columns(i).Caption + "]  = ? "
                    If i <> datatable.Columns.Count - 1 Then
                        updateString1 += " , "
                    End If
                    Dim colSQLType As OleDbType = Return_OleDBType(datatable.Columns(i).DataType.ToString())
                    updatecommand.Parameters.Add(New OleDbParameter(datatable.Columns(i).Caption, colSQLType, 0, datatable.Columns(i).Caption))
                End If

                updateString2 += "([" + datatable.Columns(i).Caption + "] = ? OR ? IS NULL AND [" + datatable.Columns(i).Caption + "] IS NULL)"

                If i <> datatable.Columns.Count - 1 Then
                    updateString2 += " AND "

                Else
                    updateString1 += " WHERE (" + updateString2 + ")"
                End If
            Next i
            For i = 0 To datatable.Columns.Count - 1
                Dim colSQLType As OleDbType = Return_OleDBType(datatable.Columns(i).DataType.ToString())
                updatecommand.Parameters.Add(New OleDbParameter("Original_" + datatable.Columns(i).Caption, colSQLType, 0, System.Data.ParameterDirection.Input, False, CType(10, System.Byte), CType(10, System.Byte), datatable.Columns(i).Caption, System.Data.DataRowVersion.Original, Nothing))
                updatecommand.Parameters.Add(New OleDbParameter("Original_" + datatable.Columns(i).Caption + "1", colSQLType, 0, System.Data.ParameterDirection.Input, False, CType(10, System.Byte), CType(10, System.Byte), datatable.Columns(i).Caption, System.Data.DataRowVersion.Original, Nothing))
            Next i

            updatecommand.CommandText = updateString1
        End Sub 'make_Update_Command


        Private Function Return_OleDBType(ByVal SystemType As String) As OleDbType
            Select Case SystemType

                Case "System.Boolean"
                    Return OleDbType.Boolean
                Case "System.Byte"
                    Return OleDbType.UnsignedTinyInt
                Case "System.Byte[]"
                    Return OleDbType.VarBinary
                Case "System.Binary"
                    Return OleDbType.VarBinary
                Case "System.DateTime"
                    Return OleDbType.DBTimeStamp
                Case "System.Decimal"
                    Return OleDbType.Decimal
                Case "System.Double"
                    Return OleDbType.Double
                Case "System.Single"
                    Return OleDbType.Single
                Case "System.Guid"
                    Return OleDbType.Guid
                Case "System.Int16"
                    Return OleDbType.SmallInt
                Case "System.Int32"
                    Return OleDbType.Integer
                Case "System.Int64"
                    Return OleDbType.BigInt
                Case "System.Object"
                    Return OleDbType.Variant
                Case "System.String"
                    Return OleDbType.VarWChar
                Case "System.UInt16"
                    Return OleDbType.UnsignedSmallInt
                Case "System.UInt32"
                    Return OleDbType.UnsignedInt
                Case "System.UInt64"
                    Return OleDbType.UnsignedBigInt
                Case "System.AnsiString"
                    Return OleDbType.VarChar
                Case "System.Currency"
                    Return OleDbType.Currency
                Case "System.Date"
                    Return OleDbType.DBDate
                Case "System.SByte"
                    Return OleDbType.TinyInt
                Case "System.Time"
                    Return OleDbType.DBTime
                Case "VarNumeric"
                    Return OleDbType.VarNumeric
                Case Else
                    Return OleDbType.Variant
            End Select
        End Function 'Return_OleDBType

#End Region

#Region "make_Delete_Command"
        'O string de comando e os parametros so atribuidos ao comando delete
        Private Sub make_Delete_Command(ByVal datatable As DataTable, ByVal deletecommand As OleDbCommand)
            Dim deleteString As String = "DELETE FROM [" + comboTables.Text + "] WHERE "

            Dim i As Integer
            For i = 0 To datatable.Columns.Count - 1
                deleteString += "( [" + datatable.Columns(i).Caption + "] = ? OR ? IS NULL AND [" + datatable.Columns(i).Caption + "] IS NULL )"

                If i <> datatable.Columns.Count - 1 Then
                    deleteString += " AND "
                End If
                deletecommand.Parameters.Add(New OleDbParameter("Original_" + datatable.Columns(i).Caption, System.Data.OleDb.OleDbType.Variant, 0, System.Data.ParameterDirection.Input, False, CType(10, System.Byte), CType(10, System.Byte), datatable.Columns(i).Caption, System.Data.DataRowVersion.Original, Nothing))
                deletecommand.Parameters.Add(New OleDbParameter("Original_" + datatable.Columns(i).Caption + "1", System.Data.OleDb.OleDbType.Variant, 0, System.Data.ParameterDirection.Input, False, CType(10, System.Byte), CType(10, System.Byte), datatable.Columns(i).Caption, System.Data.DataRowVersion.Original, Nothing))
            Next i

            deletecommand.CommandText = deleteString
        End Sub 'make_Delete_Command

#End Region

#Region "Check_If_Data_Changed"
        ' Verifica se os dados foram alterados
        Private Function Check_If_Data_Changed() As Boolean
            Try
                ' Cria um novo dataset para tratar as mudancas no dataset principal
                Dim objDataSetChanges As New DataSet()
                ' para qualquer edicao
                Me.BindingContext(accessDataSet, comboTables.Text).EndCurrentEdit()
                ' Obtem as alteracoes feitas no dataset principal
                objDataSetChanges = CType(accessDataSet.GetChanges(), DataSet)
                ' Verifica se qualquer mudana foi feita
                If Not (objDataSetChanges Is Nothing) Then
                    Return True
                Else
                    Return False
                End If
            Catch
            End Try
        End Function 'Check_If_Data_Changed

#End Region

#Region "arrange_Controls"
        'Here the control positions and other control paramters are
        'set based on the data loaded
        Private Sub arrange_Controls(ByVal startingPos As Integer, ByVal TabIndex_start As Integer)
            btnAdd.TabIndex = TabIndex_start + 1
            btnCancel.TabIndex = TabIndex_start + 2
            btnDelete.TabIndex = TabIndex_start + 3
            btnUpdate.TabIndex = TabIndex_start + 5

            startingPos += 10
            comboTables.Top = startingPos + 42
            comboTables.Left = 90

            'lblcombo.Top = startingPos + 45;
            'lblcombo.Left = 10;
            btnNavNext.Top = startingPos + 40
            btnNavNext.Left = 385

            lblNavLocation.Top = startingPos + 40
            lblNavLocation.Left = 290

            btnNavPrev.Top = startingPos + 40
            btnNavPrev.Left = 255

            btnUpdate.Top = startingPos + 42 ';80;
            btnUpdate.Left = 10

            btnCancel.Top = startingPos + 80
            btnCancel.Left = 345

            btnDelete.Top = startingPos + 80
            btnDelete.Left = 270

            btnAdd.Top = startingPos + 80
            btnAdd.Left = 190

            DataLoaded = True

            menuF_save.Enabled = True
            menuSearch.Enabled = True

            btnAdd.Visible = True
            btnCancel.Visible = True
            btnDelete.Visible = True
            btnUpdate.Visible = True
            btnNavPrev.Visible = True
            btnNavNext.Visible = True
            comboTables.Visible = True
            lblNavLocation.Visible = True

            GPostion = startingPos + 170
            dGrid.Height = Me.Height - GPostion
        End Sub 'arrange_Controls

#End Region

#Region "DataHighlighted Position Change"
        'update the lblnavlocation text
        Private Sub DataSet_PositionChanged()
            Me.lblNavLocation.Text = (Me.BindingContext(accessDataSet, comboTables.Text).Position + 1).ToString() + " of  " + Me.BindingContext(accessDataSet, comboTables.Text).Count.ToString()
        End Sub 'DataSet_PositionChanged

#End Region

#Region "Update Records in database"
        'Trata e realiza a rotina de atualizao para salvar alteraes na fonte de dados 
        Public Sub UpdateDataSet()
            ' Cria um novo dataset para tratar mudanas feitas no dataset principal
            Dim objDataSetChanges As New DataSet()
            ' Para qualquer edico de dados
            Me.BindingContext(accessDataSet, comboTables.Text).EndCurrentEdit()
            ' Obtem as mudancas feitas no dataset principal
            objDataSetChanges = CType(accessDataSet.GetChanges(), DataSet)
            ' Verifica se qualquer mudana foi feita
            If Not (objDataSetChanges Is Nothing) Then
                UpdateDataSource(objDataSetChanges)
                If Me.accessConnection.State.ToString() <> "Closed" Then
                    Me.accessConnection.Close()
                End If
            End If
        End Sub 'UpdateDataSet

        Public Sub UpdateDataSource(ByVal ChangedRows As DataSet)
            ' A fonte de dados somente precisa se atualziada se houver mudanas pendentes
            If Not (ChangedRows Is Nothing) Then
                ' abra a conexao
                Me.accessConnection.Open()
                ' tenta atualizar a fonte de dados
                Try
                    accessDataAdapter.Update(ChangedRows)
                    accessDataSet.AcceptChanges()
                    'Captura erros e exibe
                Catch e As System.Data.DBConcurrencyException
                    accessDataSet.AcceptChanges()
                    MessageBox.Show("Unfortunately this data file cannot be saved as " + "Concurrency violation, (please exit the " + "all data are rejected, please renter your data)", "Cannot Update File")
                Finally
                    Me.accessConnection.Close()
                End Try
            End If
        End Sub 'UpdateDataSource

#End Region

#Region "This Form's All Button Click Events"
        'Trata todos os eventos Click para todos
        'os controles no formulario
        Private Sub btnNavPrev_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnNavPrev.Click
            Me.BindingContext(accessDataSet, comboTables.Text).Position = Me.BindingContext(accessDataSet, comboTables.Text).Position - 1
            Me.DataSet_PositionChanged()
        End Sub 'btnNavPrev_Click
        'Proximo
        Private Sub btnNavNext_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnNavNext.Click
            Me.BindingContext(accessDataSet, comboTables.Text).Position = Me.BindingContext(accessDataSet, comboTables.Text).Position + 1
            Me.DataSet_PositionChanged()
        End Sub 'btnNavNext_Click
        'Rotina para incluir dados
        Private Sub btnAdd_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnAdd.Click
            Try
                ' limpa a edio atual
                Me.BindingContext(accessDataSet, comboTables.Text).EndCurrentEdit()
                Me.BindingContext(accessDataSet, comboTables.Text).AddNew()
            Catch eEndEdit As System.Exception
                System.Windows.Forms.MessageBox.Show(eEndEdit.Message)
            End Try

            Me.DataSet_PositionChanged()
        End Sub 'btnAdd_Click
        'Rotina para deletar
        Private Sub btnDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDelete.Click
            If Me.BindingContext(accessDataSet, comboTables.Text).Count > 0 Then
                Me.BindingContext(accessDataSet, comboTables.Text).RemoveAt(Me.BindingContext(accessDataSet, comboTables.Text).Position)
                Me.DataSet_PositionChanged()
            End If
        End Sub 'btnDelete_Click
        'Rotina para cancelar dados
        Private Sub btnCancel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCancel.Click
            Me.BindingContext(accessDataSet, comboTables.Text).CancelCurrentEdit()
            Me.DataSet_PositionChanged()
        End Sub 'btnCancel_Click
        'Atualiza e Salva as mudanas nos dados para o arquivo fonte
        Private Sub btnUpdate_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
            Try
                ' tenta atualizar o dataset
                Me.UpdateDataSet()
            Catch eUpdate As System.Data.OleDb.OleDbException
                ' Exibe erros
                System.Windows.Forms.MessageBox.Show(eUpdate.Message)
            End Try

            Me.DataSet_PositionChanged()
        End Sub 'btnUpdate_Click
        'Rotina automatica de entrada de dados
        Private Sub cMenuClick(ByVal sender As Object, ByVal e As System.EventArgs)
            Dim tempItem As MenuItem = CType(sender, MenuItem)
            tempItem.Checked = Not tempItem.Checked
        End Sub 'cMenuClick


#End Region

#Region "removeMadeControls"
        'Here all the made controls are removed
        Private Sub removeMadeControls()
            Dim i As Integer
            Do While (i < Me.Controls.Count)
                If Me.Controls(i).GetType().Name = "Label" And Me.Controls(i).Name <> "lblNavLocation" Then
                    Me.Controls(i).Dispose()
                    i = 0
                Else
                    If Me.Controls(i).GetType().Name = "TextBox" Then
                        Me.Controls(i).Dispose()
                        i = 0
                    End If
                End If
                i += 1
            Loop
        End Sub 'removeMadeControls
#End Region

#Region "comboTables_SelectedValueChanged"
        'ComboTables Value Changed Routine
        Private Sub comboTables_SelectedValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles comboTables.SelectedValueChanged
            If ComboBoxText = comboTables.Text Then
                Return
            Else
                ComboBoxText = comboTables.Text
            End If
            removeMadeControls()
            LoadData(("SELECT * FROM [" + comboTables.Text + "]"))
        End Sub 'comboTables_SelectedValueChanged

#End Region

#Region "Form Closing and Resizing Event"
        Private Sub MainFrm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
            If Check_If_Data_Changed() = True Then
                Dim r As DialogResult = MessageBox.Show("The database file changed, are sure you want exit without saving !!", "Exit Without Save", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation)
                If r = DialogResult.Yes Then
                    Application.Exit()
                Else
                    e.Cancel = True
                End If
            Else
                Application.Exit()
            End If
        End Sub 'MainFrm_Closing

        Private Sub MainFrm_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
            dGrid.Height = Me.Height - GPostion
        End Sub 'MainFrm_Resize

#End Region

#Region "Data Grid's Event"
        'Show AutoNumber Incrementation or Automatic Date
        'Insertion menu creation routine 
        Private Sub dGrid_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles dGrid.MouseDown
            'Runs for right mouse down
            Dim myGrid As DataGrid = CType(sender, DataGrid)
            Dim hti As System.Windows.Forms.DataGrid.HitTestInfo

            hti = myGrid.HitTest(e.X, e.Y)

            Select Case hti.Type
                Case System.Windows.Forms.DataGrid.HitTestType.ColumnHeader
                    If colType(hti.Column) = "System.Int32" Or colType(hti.Column) = "System.DateTime" Then
                        If e.Button <> System.Windows.Forms.MouseButtons.Right Then
                            Return
                        End If
                        AutoMenu(hti.Column).Show(dGrid, New Point(e.X, e.Y))
                    End If
            End Select
        End Sub 'dGrid_MouseDown


        'The Grid's update routine if any of the menue's are
        'checked
        Private Sub dGrid_CurrentCellChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles dGrid.CurrentCellChanged
            Me.DataSet_PositionChanged()
            Dim getRow As String() = lblNavLocation.Text.Split(" ")
            If getRow(0) <> getRow(3) Then
                Return
            End If
            Dim myGrid As DataGrid = CType(sender, DataGrid)
            Dim row As Integer = Convert.ToInt32(getRow(0))

            Dim i As Integer
            For i = 0 To (accessDataSet.Tables(comboTables.Text).Columns.Count) - 1
                If colType(i) = "System.Int32" AndAlso AutoMenu(i).MenuItems(0).Checked = True Then
                    If row > 1 Then
                        Try
                            UpdateTextBoxes(i, Convert.ToString((CInt(dGrid(dGrid.CurrentCell.RowNumber - 1, i)) + 1)))
                        Catch
                        End Try
                    End If
                End If
                If colType(i) = "System.DateTime" AndAlso AutoMenu(i).MenuItems(0).Checked = True Then
                    If (True) Then
                        UpdateTextBoxes(i, System.DateTime.Now.Date.ToString())
                    End If
                End If
            Next i
        End Sub 'dGrid_CurrentCellChanged


        'Menu Updates done in the textbox controls
        'after editing here
        Private Sub UpdateTextBoxes(ByVal Col As Integer, ByVal newValue As String)
            Dim i As Integer
            For i = 0 To (Me.Controls.Count) - 1
                If Me.Controls(i).Name = "cText" + Col.ToString() Then
                    If Me.Controls(i).Text <> "" Then
                        Return
                    End If
                    Me.Controls(i).Text = newValue
                End If
            Next i
        End Sub 'UpdateTextBoxes
#End Region

    End Class
End Namespace
