'------------------------------------------------------------------------
'
' Author      : Anas S.
' Date        : 1 Jan 2004
' Version     : 1.0
' Description : Filtra e procurar o banco de dados 
'
'------------------------------------------------------------------------
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports System.Data.OleDb


Namespace DataEasy
    _
    '/ <summary>
    '/ Summary description for Form1.
    '/ </summary>
    Public Class searchfrm
        Inherits System.Windows.Forms.Form
#Region "Private Declarations"
        Private activateMouse As Boolean = False 'a boolian to allow mouse click on the DGrid
        Private elements As Collection 'the filter menues' elements are stored here
        Private checkedMenu() As String 'the element you are looking for in the coulmn
        Private accessDataSet As New DataSet()
        Private accessConnection As New OleDbConnection()

        Private tableName As String = "" 'DataBase table name
        Private doUpdate As Boolean = True 'Update the filter menues or not 
        Private columnHit As Integer 'which column in the table is hit
        Private WithEvents dGrid As System.Windows.Forms.DataGrid
        Private FilterMenu() As System.Windows.Forms.ContextMenu 'the filter menues for all the columns
        Private cBoxParamets As System.Windows.Forms.ComboBox 'the combobox which holds the column names
        'to chose from in the search
        Private WithEvents searchTxt As System.Windows.Forms.TextBox 'the search element is put here
        'for the text based search
        Private WithEvents Findbtn As System.Windows.Forms.Button 'find row in data according to text based search
        Private WithEvents btnRestore As System.Windows.Forms.Button 'remove all filters button
        Private MFRM As Form
#End Region
        Private lblSelectString As System.Windows.Forms.TextBox
        Friend WithEvents Label1 As System.Windows.Forms.Label
        Friend WithEvents Label2 As System.Windows.Forms.Label
        Friend WithEvents Label3 As System.Windows.Forms.Label

        '/ <summary>
        '/ Required designer variable.
        '/ </summary>
        Private components As System.ComponentModel.Container = Nothing

        'The search class constructor
        Public Sub New(ByVal motherFrm As Form, ByVal datasource As String, ByVal table_Name As String, ByVal SelectString As String)
            InitializeComponent()

            'This refers to the parent form
            MFRM = motherFrm
            'the tablename to do the search on
            tableName = table_Name

            'Initializing the connection here to the source mdb file
            CType(Me.accessDataSet, System.ComponentModel.ISupportInitialize).BeginInit()
            accessConnection.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + datasource
            accessConnection.Open()
            loadData(SelectString)
            lblSelectString.Text = "Seleciona Comando = " + SelectString
            activateMouse = True
            accessConnection.Close()

            Dim myDataTable As DataTable = accessDataSet.Tables(tableName)

            'Find all columns and put them in the combobox
            'cBoxParamets
            Dim i As Integer
            For i = 0 To myDataTable.Columns.Count - 1
                cBoxParamets.Items.Add(myDataTable.Columns(i).Caption)
                If i = 0 Then
                    cBoxParamets.Text = myDataTable.Columns(i).Caption
                End If
            Next i
            dGrid.Height = Me.Height - 175
        End Sub 'New


        '/ <summary>
        '/ Clean up any resources being used.
        '/ </summary>
        Protected Overloads Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub 'Dispose


#Region "Windows Form Designer generated code"
        '/ <summary>
        '/ Required method for Designer support - do not modify
        '/ the contents of this method with the code editor.
        '/ </summary>
        Private Sub InitializeComponent()
            Me.dGrid = New System.Windows.Forms.DataGrid
            Me.cBoxParamets = New System.Windows.Forms.ComboBox
            Me.searchTxt = New System.Windows.Forms.TextBox
            Me.Findbtn = New System.Windows.Forms.Button
            Me.btnRestore = New System.Windows.Forms.Button
            Me.lblSelectString = New System.Windows.Forms.TextBox
            Me.Label1 = New System.Windows.Forms.Label
            Me.Label2 = New System.Windows.Forms.Label
            Me.Label3 = New System.Windows.Forms.Label
            CType(Me.dGrid, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.SuspendLayout()
            '
            'dGrid
            '
            Me.dGrid.AccessibleRole = System.Windows.Forms.AccessibleRole.ColumnHeader
            Me.dGrid.AllowSorting = False
            Me.dGrid.DataMember = ""
            Me.dGrid.Dock = System.Windows.Forms.DockStyle.Bottom
            Me.dGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText
            Me.dGrid.Location = New System.Drawing.Point(0, 135)
            Me.dGrid.Name = "dGrid"
            Me.dGrid.ReadOnly = True
            Me.dGrid.Size = New System.Drawing.Size(605, 336)
            Me.dGrid.TabIndex = 1
            '
            'cBoxParamets
            '
            Me.cBoxParamets.Location = New System.Drawing.Point(16, 30)
            Me.cBoxParamets.Name = "cBoxParamets"
            Me.cBoxParamets.Size = New System.Drawing.Size(341, 21)
            Me.cBoxParamets.TabIndex = 2
            Me.cBoxParamets.Text = "Tabelas"
            '
            'searchTxt
            '
            Me.searchTxt.Location = New System.Drawing.Point(16, 70)
            Me.searchTxt.Name = "searchTxt"
            Me.searchTxt.Size = New System.Drawing.Size(577, 20)
            Me.searchTxt.TabIndex = 3
            '
            'Findbtn
            '
            Me.Findbtn.Location = New System.Drawing.Point(363, 30)
            Me.Findbtn.Name = "Findbtn"
            Me.Findbtn.Size = New System.Drawing.Size(112, 32)
            Me.Findbtn.TabIndex = 4
            Me.Findbtn.Text = "Procurar"
            '
            'btnRestore
            '
            Me.btnRestore.Location = New System.Drawing.Point(481, 30)
            Me.btnRestore.Name = "btnRestore"
            Me.btnRestore.Size = New System.Drawing.Size(112, 32)
            Me.btnRestore.TabIndex = 5
            Me.btnRestore.Text = "Restaurar"
            '
            'lblSelectString
            '
            Me.lblSelectString.BackColor = System.Drawing.Color.FromArgb(CType(CType(255, Byte), Integer), CType(CType(255, Byte), Integer), CType(CType(192, Byte), Integer))
            Me.lblSelectString.ForeColor = System.Drawing.Color.Black
            Me.lblSelectString.Location = New System.Drawing.Point(16, 109)
            Me.lblSelectString.Name = "lblSelectString"
            Me.lblSelectString.ReadOnly = True
            Me.lblSelectString.Size = New System.Drawing.Size(577, 20)
            Me.lblSelectString.TabIndex = 6
            Me.lblSelectString.Text = "Selecionar Comando"
            '
            'Label1
            '
            Me.Label1.AutoSize = True
            Me.Label1.Location = New System.Drawing.Point(18, 54)
            Me.Label1.Name = "Label1"
            Me.Label1.Size = New System.Drawing.Size(194, 13)
            Me.Label1.TabIndex = 7
            Me.Label1.Text = "Informe o critrio para Selecionar dados"
            '
            'Label2
            '
            Me.Label2.AutoSize = True
            Me.Label2.Location = New System.Drawing.Point(18, 93)
            Me.Label2.Name = "Label2"
            Me.Label2.Size = New System.Drawing.Size(239, 13)
            Me.Label2.TabIndex = 8
            Me.Label2.Text = "Instruo SQL montada para extrao dos dados"
            '
            'Label3
            '
            Me.Label3.AutoSize = True
            Me.Label3.Location = New System.Drawing.Point(18, 9)
            Me.Label3.Name = "Label3"
            Me.Label3.Size = New System.Drawing.Size(152, 13)
            Me.Label3.TabIndex = 9
            Me.Label3.Text = "Selecione um campo para filtro"
            '
            'searchfrm
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(605, 471)
            Me.Controls.Add(Me.Label3)
            Me.Controls.Add(Me.Label2)
            Me.Controls.Add(Me.Label1)
            Me.Controls.Add(Me.lblSelectString)
            Me.Controls.Add(Me.btnRestore)
            Me.Controls.Add(Me.Findbtn)
            Me.Controls.Add(Me.searchTxt)
            Me.Controls.Add(Me.cBoxParamets)
            Me.Controls.Add(Me.dGrid)
            Me.MinimizeBox = False
            Me.MinimumSize = New System.Drawing.Size(352, 360)
            Me.Name = "searchfrm"
            Me.Text = "AcessoFcil : Procurar na base de dados"
            CType(Me.dGrid, System.ComponentModel.ISupportInitialize).EndInit()
            Me.ResumeLayout(False)
            Me.PerformLayout()

        End Sub 'InitializeComponent

#End Region

#Region "load Data"
        'Carrega os dados do arquivo mdb para o Grid
        Private Sub loadData(ByVal SelectString As String)
            accessDataSet.RejectChanges()
            accessDataSet.Clear()

            Dim accessSelectCommand As New OleDbCommand()
            Dim accessInsertCommand As New OleDbCommand()
            Dim accessDataAdapter As New OleDbDataAdapter()

            accessSelectCommand.CommandText = SelectString
            accessSelectCommand.Connection = accessConnection
            accessDataAdapter.SelectCommand = accessSelectCommand

            ' Tenta preencher o dataset atraves do objeto OleDbDataAdapter1.
            accessDataAdapter.TableMappings.AddRange(New System.Data.Common.DataTableMapping() {New System.Data.Common.DataTableMapping("Table", tableName)})
            accessDataAdapter.Fill(accessDataSet)

            dGrid.SetDataBinding(accessDataSet, tableName)

            Dim col As Integer = accessDataSet.Tables(tableName).Columns.Count
            Dim row As Integer = accessDataSet.Tables(tableName).Rows.Count

            If doUpdate = True Then
                checkedMenu = New [String](col - 1) {}
            End If

            elements = New Collection()

            'elements = New Object()(col) {}
            FilterMenu = New ContextMenu(col - 1) {}

            Dim i As Integer
            For i = 0 To col - 1
                elements.Add(New Object(row - 1) {})
                If doUpdate = True Then
                    checkedMenu(i) = "Nada"
                End If
            Next i

            For i = 0 To col - 1
                Dim j As Integer
                For j = 0 To row - 1
                    If dGrid(j, i).GetType().Name = "Int32" Or dGrid(j, i).GetType().Name = "DateTime" Or dGrid(j, i).GetType().Name = "Decimal" Then
                        elements.Item(i + 1)(j) = dGrid(j, i)
                    Else
                        elements.Item(i + 1)(j) = dGrid(j, i).ToString()
                    End If
                Next j
            Next i

            For i = 0 To col - 1
                Try
                    Array.Sort(elements.Item(i + 1))
                Catch
                End Try
                FilterMenu(i) = New ContextMenu()
                Console.WriteLine(elements(i + 1)(0))
                make_menues(elements(i + 1), FilterMenu(i))
            Next i
        End Sub 'loadData

#End Region

#Region "Make Menues"
        'Cria e atualiza os filtros dos menus conforme o exibido no grid
        Private Sub make_menues(ByVal array_elements() As Object, ByVal cMenu As System.Windows.Forms.ContextMenu)
            Dim Prev_Element As String = ""

            Dim mfirstItems As MenuItem = New MenuItem("Nada")
            AddHandler mfirstItems.Click, AddressOf Me.cMenuClick
            'mfirstItems.Click += New System.EventHandler(Me.cMenuClick)
            cMenu.MenuItems.Add(mfirstItems)

            Dim mItems() As System.Windows.Forms.MenuItem = New MenuItem(array_elements.Length) {}
            Dim i As Integer
            For i = 0 To array_elements.Length - 1
                If Prev_Element <> array_elements(i).ToString() Then
                    mItems(i) = New MenuItem(array_elements(i).ToString())
                    AddHandler mItems(i).Click, AddressOf Me.cMenuClick
                    cMenu.MenuItems.Add(mItems(i))
                    Prev_Element = array_elements(i).ToString()
                End If
            Next i
        End Sub 'make_menues

#End Region

#Region "Filter Menu Click Event"
        'Esta rotina trata o evento Click do filtro do menu
        Private Sub cMenuClick(ByVal sender As Object, ByVal e As System.EventArgs)
            doUpdate = False
            Dim tempItem As MenuItem = CType(sender, MenuItem)
            Dim accessDataTable As DataTable = accessDataSet.Tables(tableName)

            If accessDataTable.Columns(columnHit).DataType.ToString() = "System.Byte[]" Then
                MessageBox.Show("Este DataType no pode ser filtrado", "No foi possvel filtrar", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Return
            End If

            checkedMenu(columnHit) = tempItem.Text
            Try
                loadData(MakeSelectString(checkedMenu))
                lblSelectString.Text = "Seleciona Comando = " + MakeSelectString(checkedMenu)
            Catch
            End Try
        End Sub 'cMenuClick

#End Region

#Region "Make the Select Command"
        'Rotina que cria o comando de busca para ser usado
        'como um comando de seleo baseado nas opes
        'defindas pelo usurio 
        Private Function MakeSelectString(ByVal MenuChecked() As String) As String
            Dim accessDataTable As DataTable = accessDataSet.Tables(tableName)
            Dim STselect As String = "Select * From " + tableName + " Where "
            Dim there_is_Change As Boolean = False
            Dim i As Integer
            For i = 0 To MenuChecked.Length - 1

                Dim colType As String = accessDataTable.Columns(i).DataType.ToString()


                If MenuChecked(i) <> "Nada" Then
                    If i <> 0 And there_is_Change = True Then

                        If colType = "System.String" Then
                            STselect += " And [" + accessDataSet.Tables(tableName).Columns(i).Caption + " ] = '" + MenuChecked(i) + "'"
                        Else
                            If colType = "System.DateTime" Then
                                STselect += " And [" + accessDataSet.Tables(tableName).Columns(i).Caption + " ] = #" + MenuChecked(i) + "#"
                            Else
                                STselect += " And [" + accessDataSet.Tables(tableName).Columns(i).Caption + " ] = " + MenuChecked(i)
                            End If
                        End If
                    Else
                        If colType = "System.String" Then
                            STselect += " [" + accessDataSet.Tables(tableName).Columns(i).Caption + " ] = '" + MenuChecked(i) + "'"
                        Else
                            If colType = "System.DateTime" Then
                                STselect += " [" + accessDataSet.Tables(tableName).Columns(i).Caption + " ] = #" + MenuChecked(i) + "#"
                            Else
                                STselect += " [" + accessDataSet.Tables(tableName).Columns(i).Caption + " ] = " + MenuChecked(i)
                            End If
                        End If
                    End If
                    there_is_Change = True
                End If
            Next i
            If there_is_Change = False Then
                STselect = "Select * From " + tableName
            End If
            lblSelectString.Text = "Seleciona Comando = " + STselect
            Return STselect
        End Function 'MakeSelectString

#End Region

#Region "Data Grid Mouse Down Event"
        'Cria e carrega os filtros do menu
        'e exibe se o usurio clicar com o boto direito em qualquer coluna do grid
        Private Sub dGrid_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles dGrid.MouseDown
            If activateMouse = False Then
                Return
            End If
            If e.Button <> System.Windows.Forms.MouseButtons.Right Then
                Return
            End If
            Dim myGrid As DataGrid = CType(sender, DataGrid)
            Dim hti As System.Windows.Forms.DataGrid.HitTestInfo
            hti = myGrid.HitTest(e.X, e.Y)


            Select Case hti.Type
                Case System.Windows.Forms.DataGrid.HitTestType.ColumnHeader
                    'message += "the column header for column " + hti.Column
                    columnHit = hti.Column
                    FilterMenu(hti.Column).Show(dGrid, New Point(e.X, e.Y))
            End Select
        End Sub 'dGrid_MouseDown

#End Region

#Region "Text based search"
        'O boto Procurar foi clicado
        Private Sub Findbtn_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Findbtn.Click
            find_the_data()
        End Sub 'Findbtn_Click
        'Busca os dados baseado no elemento requirido na string de busca
        Private Sub find_the_data()
            Dim index As Integer = 0
            If searchTxt.Text = "" Then
                Return
            End If
            Dim accessDataTable As DataTable = accessDataSet.Tables(tableName)
            Dim CommandText As String = "SELECT * FROM " + tableName + " Where [" + cBoxParamets.Text + "] = "
            Try
                Dim i As Integer
                For i = 0 To (accessDataSet.Tables(tableName).Columns.Count) - 1
                    If cBoxParamets.Text = cBoxParamets.Items(i).ToString() Then
                        index = i
                    End If
                    checkedMenu(i) = "Nada"
                Next i

                If accessDataTable.Columns(index).DataType.ToString() = "System.Byte[]" Then
                    MessageBox.Show("This DataType Cannot Be Filtered", "Unable To Do Filter", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    Return
                End If

                If accessDataTable.Columns(index).DataType.ToString() = "System.String" Then
                    CommandText += " '" + searchTxt.Text + "'"
                Else
                    If accessDataTable.Columns(index).DataType.ToString() = "System.DateTime" Then
                        CommandText += " #" + searchTxt.Text + "#"
                    Else
                        CommandText += searchTxt.Text
                    End If
                End If
                loadData(CommandText)
                lblSelectString.Text = "Seleciona Comando = " + CommandText
            Catch
            End Try
        End Sub 'find_the_data
        'Remove todos os filtros e exibe todos os dados
        Private Sub btnRestore_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnRestore.Click
            Dim i As Integer
            For i = 0 To (accessDataSet.Tables(tableName).Columns.Count) - 1
                checkedMenu(i) = "Nada"
            Next i
            loadData(("Select * From " + tableName))
            lblSelectString.Text = "Seleciona Comando = Select * From " + tableName
        End Sub 'btnRestore_Click
        'O usurio clicou a tela ENTER ao inves do boto Procurar o efeito deve ser o mesmo
        Private Sub searchTxt_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles searchTxt.KeyDown
            If e.KeyCode = Keys.Enter Then
                find_the_data()
            End If
        End Sub 'searchTxt_KeyDown
        'Busca dinamica com a mudana de criterio informada pelo usuario
        Private Sub searchTxt_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles searchTxt.TextChanged
            Dim index As Integer = 0
            If searchTxt.Text = "" Then
                lblSelectString.Text = "Seleciona Comando = Select * From " + tableName
                loadData(("Select * From " + tableName))
                Return
            End If
            Dim accessDataTable As DataTable = accessDataSet.Tables(tableName)
            Dim CommandText As String = "SELECT * FROM " + tableName + " Where [" + cBoxParamets.Text + "] Like "
            Try
                Dim i As Integer
                For i = 0 To (accessDataSet.Tables(tableName).Columns.Count) - 1
                    If cBoxParamets.Text = cBoxParamets.Items(i).ToString() Then
                        index = i
                    End If
                    checkedMenu(i) = "Nada"
                Next i

                If accessDataTable.Columns(index).DataType.ToString() = "System.Byte[]" Then
                    MessageBox.Show("This DataType Cannot Be Filtered", "Unable To Do Filter", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    Return
                End If

                CommandText += " '" + searchTxt.Text + "%'"
                loadData(CommandText)
                lblSelectString.Text = "Seleciona Comando = " + CommandText
            Catch
            End Try
        End Sub 'searchTxt_TextChanged
#End Region

#Region "search Form events"
        'From Resize routine
        Private Sub searchfrm_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
            dGrid.Height = Me.Height - 135
        End Sub 'searchfrm_Resize


        'Form Closing Routine
        Private Sub searchfrm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
            MFRM.Enabled = True
        End Sub 'searchfrm_Closing
#End Region
    End Class 'searchfrm 
End Namespace 'DataEasy